PPATH  Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the fourdigit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a nonprime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given fourdigit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are fourdigit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
rraj001:
20160515 12:21:45
nice problem,AC in one go!!!


dwij28:
20160411 08:26:36
Bfs and Sieve of Eratosthenes.. :) Time limit and test cases are very lenient so it passes even if algorithm for checking single digit difference takes 0(n^2), where n is the no. of 4 digit primes.. 

karthik1997:
20160323 14:33:41
Simple Sieve and a BFS . Ac in one go . Learnt the importance of implementation rather than the algo :P 

hardik agrawal:
20160227 13:36:20
nice problem :D


dhumketu:
20160127 15:51:46
Literally Nothing is IMPOSSIBLE!! :D Didn't even consider a possibility of impossible. 

Abhishek Naik:
20160124 14:29:24
One important thing that I noticed  The next number in the sequence can be smaller than the previous one. For e.g., my accepted program gives the following output for the 1st test case (printed in the reverse order due to backtracking):


Deepak :
20160119 14:41:34
nice one..AC in one go. 

anandrohit:
20160115 12:09:25
Importance of < & <=


lakshay_v06:
20160114 15:41:50
Gr8 ques! Basic graph theory + sieve ! Done in 0.00! :D 

abhinav_rai:
20151217 23:00:29
Cool Problem. Made me remember bfs and heights along with sieve and how to check for single digit change. Indeed great problem!! 
Added by:  overwise 
Date:  20071002 
Time limit:  2s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: ERL JSRHINO NODEJS PERL6 VB.NET 
Resource:  ACM ICPC NWERC 2006 